package interfaz.dialogos;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;

import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.text.BadLocationException;
import javax.swing.text.JTextComponent;

public class JMessageText extends JTextArea {
	
	/** serial version uid. */
	private static final long serialVersionUID = 8674829277697895228L;
	
	private void init () {
		this.setEditable(false);  
		this.setCursor(null);
		this.setBorder(  null );
		this.setOpaque(false);
		this.setBackground(new Color(0, 0, 0, 0));
		
		this.setFocusable(false);
		this.setLineWrap(true);
		this.setWrapStyleWord( true );
		Font f = UIManager.getFont( "Label.font" );
		f = f.deriveFont( (float) 13 );
		this.setFont( f );
	}
	
	public JMessageText ( String s ) {
	
		this.init();

		this.setText( s );
	}
	
	public JMessageText() {
		this.init();
		
		this.setText(" ");
	}

	public void setText ( String s ) {
		super.setText( s );
		
		setCorrectDimensionToJTextComponent( this );
	}
	
	private void setCorrectDimensionToJTextComponent ( JTextComponent x ) {
		
        int height = 600;
        int width = 100;
        
		Dimension initialSize = new Dimension ( width, height );
		
		x.setPreferredSize(initialSize);
		x.setSize(initialSize);            
        
		Rectangle r_pos = new Rectangle ( );

		try {
			boolean fin = false;
			int length = x.getDocument( ).getLength( );
			
			while ( !fin ) {
				r_pos = x.modelToView( length );
				
				height = r_pos.y + r_pos.height;
				if ( height * 4 < width || width >= 800 )
					fin = true;
				else 
					width += 100;
				
				Dimension actualSize = new Dimension ( width, height );
				x.setPreferredSize( actualSize);
				x.setSize( actualSize );
			}
		} catch ( BadLocationException e ) {
			e.printStackTrace();
		}
		this.revalidate( );
	}
}
