package interfaz.dialogos.dialogoSalir;

import interfaz.dialogos.JMessageText;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import negocio.PreferenciasSingleton;
import net.miginfocom.swing.MigLayout;

public class DialogoSalir extends JDialog {
	/** serial version uid. */
	private static final long serialVersionUID = 8674829277697895228L;
	
	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	/** Esta propiedad sirve para usar this en las clases internas. */
	JDialog this_dialog = this;
	
	public static int GUARDAR = 1;
	public static int NO_GUARDAR = 2;
	public static int CANCELAR = 0;
	
	public int resultado;
	
	static String s_GUARDAR =  idiomas.getString( "eti_botGuardar" );
	static String s_NO_GUARDAR = idiomas.getString( "eti_botNoGuardar" );
	static String s_CANCELAR = idiomas.getString( "eti_botCancelar" );
	//static String s_GUARDAR_PREFERENCIAS = idiomas.getString( "eti_preferencias" );
	
	/** Botón GUARDAR */
	private JButton botGuardarSesión = new JButton( DialogoSalir.s_GUARDAR );
	private ActionListener aclGuardarSesión = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = GUARDAR;
			
			this_dialog.setVisible( false );
			/*negocio.guigprof.guardarSesión();
			*//** Salir de la aplicación *//*
			negocio.guigprof.cerrarAplicacion( );*/
		}
	};
	{ /** Añadir los actionListener a los botones. */
		botGuardarSesión.addActionListener( aclGuardarSesión );
	}

	/** Botón NO GUARDAR */
	private JButton botNoGuardarSesión = new JButton( DialogoSalir.s_NO_GUARDAR );
	private ActionListener aclNoGuardarSesión = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = NO_GUARDAR;
			
			this_dialog.setVisible( false );
			/** Salir de la aplicación *//*
			negocio.guigprof.cerrarAplicacion( );*/
		}
	};
	{/** Añadir los actionListener a los botones. */
		botNoGuardarSesión.addActionListener( aclNoGuardarSesión );
	}

	
	/** Botón CANCELAR */
	private JButton botCancelar = new JButton( DialogoSalir.s_CANCELAR );
	private ActionListener aclCancelar = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = CANCELAR;
			this_dialog.setVisible( false );
			
			/*this_dialog.dispose( );*/			
		}
	};
	{ /** Añadir los actionListener a los botones. */
		botCancelar.addActionListener( aclCancelar );
	}
	
	
	/** Pregunta antes de cerrar */
	private JMessageText pregunta_cerrar = new JMessageText( idiomas.getString( "q_cerrar-dialog" ));
	
	public int showDialog( ) {
		this.setModalityType( JDialog.ModalityType.APPLICATION_MODAL  );
		this.setVisible( true );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		return resultado; 
	}

	/**
	 * Constructor de la clase 
	 * @param owner
	 */
	public DialogoSalir( Frame owner ) {
		/** ventana padre, título del diálogo y que sea modal*/
		super(owner, idiomas.getString( "eti_salir-dialog"), true );
		
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		
		/** colocar elementos del diálogo. */
		this.setLayout( new MigLayout ( "fill, inset unrel" ) );
		this.add( new JLabel( UIManager.getIcon("OptionPane.questionIcon") ), "gap unrel, align center" );
		this.add( pregunta_cerrar, "align center,  wrap, gap unrel" ); //alinear centro	
		
		/** añadir botones Sí No Cancelar */
		this.add( this.botGuardarSesión, "gaptop unrel, span 2, split 3, align center,sg botones");
		this.add( this.botNoGuardarSesión, "sg botones" );
		this.add( this.botCancelar, "gapbefore unrel, sg botones" );
		
		/** default button -> Guardar */
		this.getRootPane().setDefaultButton( botGuardarSesión );		
		
		/** ESC button -> Cancelar */
		KeyStroke esc = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
	    this.getRootPane( ).registerKeyboardAction( aclCancelar, "ACTION_CLOSE", esc, JComponent.WHEN_IN_FOCUSED_WINDOW);
		
	    /** Empaquetar y colocar */
		this.pack( );
		this.setLocationRelativeTo( owner );
		this.setResizable( false );
	}
	
	
	/** Función main para pruebas. */
	public static void main(String[] args) {

		javax.swing.JFrame v = new javax.swing.JFrame("PRUEBA");
		javax.swing.JPanel p = new javax.swing.JPanel();
		
		v.add( p );
		v.setDefaultCloseOperation( javax.swing.JFrame.DO_NOTHING_ON_CLOSE );
		v.setSize( 350 , 350 );
		v.addWindowListener( new DialogoCerrarWindowListener( v ) );
		
		v.setVisible( true );
	}
}

