package interfaz.dialogos.dialogoSesion;

import interfaz.dialogos.JMessageText;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import net.miginfocom.swing.MigLayout;

public class DialogoSesion extends JDialog {
	/** serial version uid. */
	private static final long serialVersionUID = 4829277697895228L;
	
	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos");
	
	/** Esta propiedad sirve para usar this en las clases internas. */
	JDialog this_dialog = this;
	
	public final static int GUARDAR = 1;
	public final static int DESECHAR = 2;
	public final static int AÑADIR = 3;
	public final static int CANCELAR = 0;

	
	public int resultado;
	
	static String s_GUARDAR =  idiomas.getString( "eti_botGuardar" );
	static String s_DESECHAR = idiomas.getString( "eti_botDesecharSesion" );
	static String s_CANCELAR = idiomas.getString( "eti_botCancelar" );
	static String s_AÑADIR = idiomas.getString( "eti_botAñadirSesion" );
	
	static String TITULO_DIALOGO = idiomas.getString( "eti_sesion-dialog");
	
	/** Botón AÑADIR */
	private JButton botAñadirSesion = new JButton( DialogoSesion.s_AÑADIR );
	private ActionListener aclAñadirSesion = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = AÑADIR;
			this_dialog.setVisible( false );
		}
	};
	{ /** Añadir los actionListener a los botones. */
		botAñadirSesion.addActionListener( aclAñadirSesion );
	}
	
	
	/** Botón GUARDAR */
	private JButton botGuardarSesión = new JButton( DialogoSesion.s_GUARDAR );
	private ActionListener aclGuardarSesión = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = GUARDAR;
			
			this_dialog.setVisible( false );
		}
	};
	{ /** Añadir los actionListener a los botones. */
		botGuardarSesión.addActionListener( aclGuardarSesión );
	}

	/** Botón NO GUARDAR */
	private JButton botDesecharSesión = new JButton( DialogoSesion.s_DESECHAR );
	private ActionListener aclDesecharSesión = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = DESECHAR;
			
			this_dialog.setVisible( false );
		}
	};
	{/** Añadir los actionListener a los botones. */
		botDesecharSesión.addActionListener( aclDesecharSesión );
	}

	
	/** Botón CANCELAR */
	private JButton botCancelar = new JButton( DialogoSesion.s_CANCELAR );
	private ActionListener aclCancelar = new ActionListener () {
		public void actionPerformed( ActionEvent e) {
			resultado = CANCELAR;
			this_dialog.setVisible( false );
		}
	};
	{ /** Añadir los actionListener a los botones. */
		botCancelar.addActionListener( aclCancelar );
	}
	
//TODO	private JCheckBox cbxGuardarPreferencias = new JCheckBox( DialogoCerrar.GUARDAR_PREFERENCIAS );
	
	
	/** Pregunta antes de cerrar */
	private JMessageText pregunta_sesion = new JMessageText( idiomas.getString( "q_sesion-dialog" ));
	
	public int showDialog( ) {
		this.setModalityType( JDialog.ModalityType.APPLICATION_MODAL  );
		this.setVisible( true );
		this.setLocationRelativeTo( this.getParent( ) );
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		return resultado; 
	}

	/**
	 * Constructor de la clase 
	 * @param owner
	 */
	public DialogoSesion( Frame owner ) {
		/** ventana padre, título del diálogo y que sea modal*/
		super(owner, TITULO_DIALOGO, true );
		
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		
		/** colocar elementos del diálogo. */
		this.setLayout( new MigLayout ( "fill, inset unrel" ) );
		
		this.add( new JLabel( UIManager.getIcon("OptionPane.questionIcon") ), "gap unrel" );
		this.add( pregunta_sesion, "align center, wrap, gap unrel" ); //alinear centro	
		/** añadir botones Añadir Guardar Desechar Cancelar */
		this.add( this.botAñadirSesion, "gaptop unrel, span 3, split 4, align center,sg botones");
		this.add( this.botGuardarSesión, "sg botones" );
		this.add( this.botDesecharSesión, "sg botones" );
		this.add( this.botCancelar, "gapbefore unrel, sg botones" );
		
		/** default button -> Guardar */
		this.getRootPane().setDefaultButton( botAñadirSesion );		
		
		/** ESC button -> Cancelar */
		KeyStroke esc = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
	    this.getRootPane( ).registerKeyboardAction( aclCancelar, "ACTION_CLOSE", esc, JComponent.WHEN_IN_FOCUSED_WINDOW);
		
	    /** Empaquetar y colocar */
		this.pack( );
		this.setLocationRelativeTo( owner );
		this.setResizable( false );
	}
	

	
	/** Función main para pruebas. */
	public static void main(String[] args) {
		javax.swing.JFrame v = new javax.swing.JFrame( TITULO_DIALOGO );
		javax.swing.JPanel p = new javax.swing.JPanel( );
		javax.swing.JButton b = new javax.swing.JButton(
				"Mostrar diálogo Sesion" );
		p.add( b );
		v.setContentPane( p );
		v.pack( );
		
		final DialogoSesion d = new DialogoSesion( v );

		b.addActionListener( new ActionListener( ) {
			public void actionPerformed ( ActionEvent e ) {
				d.showDialog( );
			}
		} );

		v.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE );
		v.setVisible( true );
	}

}

