/**
 * 
 */
package interfaz.grafico;

import java.awt.Color;


/**
 * @author angel
 *
 */
public interface GraficoModel {
	/** Borra el listener de la lista de los que se notifican cuando ha ocurrido un cambio.
	 * @param l
	 */
    void 	removeGraficoModelListener  (GraficoModelListener l);
    /** Añade el listener a la lista de los que se notifican cuando ha ocurrido un cambio.
     * @param l
     */
	 void 	addGraficoModelListener(GraficoModelListener l);
     /** Devuelve el número de porciones del Modelo.
      * @return
      */
     int 	getSize();
     /** Devuelve la suma total de los valores de todas las porciones. Debe
      * ser igual a la suma de todos estos. Si no, el gráfico podría
      * tener un comportamiento indeseado.
      * @return
      */
     Double	getSum();
     /** Devuelve el nombre de la porción porciónIndex.
      * @param porcionIndex
      * @return
      */
     String 	getPorcionName(int porcionIndex);
     /** Devuelve el valor de la porción porciónIndex
      * @param porcionIndex
      * @return
      */
     Double    getValueAt(int porcionIndex);
     /**
      * Devuelve el color de la porción
      * @param porcionIndex
      * @return
      */
     Color getPorcionColor(int porcionIndex);
     /** Devuelve true si la porción porcionIndex es editable.
      * @param porcionIndex
      * @return
      */
     boolean 	isPorcionEditable (int porcionIndex);
     /** Coloca el valor porcionValue y el nombre porcionName en la porción porcionIndex.     
      * @param porcionValue
      * @param porcionName
      * @param porcionIndex
      */
     void 	setValueAt(Double porcionValue, String porcionName, int porcionIndex);
     
     /** Añade una nueva porcion de valor porcionValue y de nombre porcionName
      * @param porcionValue
      * @param porcionName
      */
     void addValue(Double porcionValue, String porcionName);

}
