package interfaz.vcompilacion;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ResourceBundle;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class DialogoEditar extends JDialog {
	
	/** serial Version UID */
	private static final long	serialVersionUID	= 1L;

	
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle					idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos" );
	/**
	 * recursos de iconos etc...
	 */
	ResourceBundle					recursos			= ResourceBundle
																.getBundle( "interfaz.Recursos" );

	public int OK_OPTION = JOptionPane.OK_OPTION;
	
	private JTextField	txtComandoAEditar = new JTextField(50);

	private JCheckBox	chbComandoAuto		= new JCheckBox( idiomas.getString( "eti_comandoAuto" ) );
	
	private class ControladorCheckBox implements ItemListener {

		@Override
		public void itemStateChanged ( ItemEvent e ) {
			if ( chbComandoAuto.isSelected( ) ) {
				txtComandoAEditar.setEnabled( false );
			}
			else {
				txtComandoAEditar.setEnabled( true );
			}
		}
		
	}
	{
		chbComandoAuto.addItemListener( new ControladorCheckBox() );
	}
	
	private String		cadbtnOK			= idiomas.getString( "eti_botOk" );
	private String		cadbtnCancelar		= idiomas.getString( "eti_botCancelar" );
	
	private String		titulo;

	

	/** Creando dialogo editar. */
	public DialogoEditar ( String cadena ) {
		super();

		this.titulo = ( idiomas.getString( "eti_titulo_dialogo_editar" ) );

		this.txtComandoAEditar.setText( cadena );
	
		this.chbComandoAuto.setSelected( false );
		
		this.setResizable( true );
		
		setDefaultCloseOperation( HIDE_ON_CLOSE );
	}
	
	/** Creando dialogo editar. */
	public DialogoEditar ( String cadena , boolean comandoAuto ) {
		super();

		this.titulo = ( idiomas.getString( "eti_titulo_dialogo_editar" ) );

		this.txtComandoAEditar.setText( cadena );
	
		this.chbComandoAuto.setSelected( comandoAuto );
		
		this.setResizable( true );
		
		setDefaultCloseOperation( HIDE_ON_CLOSE );
		
	}




	static public void main (String [] args) {
		DialogoEditar d = new DialogoEditar( "hola" );
		d.showDialog( new javax.swing.JFrame() );
	}

	public int showDialog ( Component parent ) {
		// Create an array of the text and components to be displayed.
		String strComandoAEditar = idiomas.getString( "eti_comandoAEditar" );
		Object [] array = { strComandoAEditar, txtComandoAEditar,
				chbComandoAuto };

		// Create an array specifying the number of dialog buttons
		// and their text.
		Object [] options = { cadbtnOK, cadbtnCancelar };

		// Create the JOptionPane.
		return JOptionPane.showOptionDialog( parent , array, titulo, JOptionPane.OK_CANCEL_OPTION ,
				JOptionPane.QUESTION_MESSAGE , null , options , options[0] );
	}


	public String getComando ( ) {
		return this.txtComandoAEditar.getText( );
	}


	public boolean getComandoAuto ( ) {
		return this.chbComandoAuto.isSelected( );
	}

}
