package interfaz.vcompilacion;

import interfaz.dialogos.dialogoDirectorio.JDirectoryChooser;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ResourceBundle;


import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;


public class DialogoNuevaCompilacion extends JDialog implements ActionListener /*DocumentListener*/ {
	
	/** serial Version UID */
	private static final long	serialVersionUID	= -2201823396167528830L;
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	static ResourceBundle					idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos" );
	/**
	 * recursos de iconos etc...
	 */
	static ResourceBundle					recursos			= ResourceBundle
																.getBundle( "interfaz.Recursos" );

	public static int OK_OPTION = JOptionPane.OK_OPTION;
	
	public static String TITULO_DIALOGO = idiomas.getString( "eti_titulo_dialogo_nuevaCompilacion" );
	
//	private String		nombreEjecutable	= null;
	private JTextField	txtNombreEjecutable = new JTextField(50);
	
	private File 		directorioTrabajo	= null;
	private JLabel		lblDirectorioTrabajo	= new JLabel();
	private JButton		btnCambiarDT		= null;

	private static String		cadbtnOK	= idiomas.getString( "eti_botOk" );
	private static String		cadbtnCancelar	= idiomas.getString( "eti_botCancelar" );

	/**
	 * Returns null if the typed string was invalid; otherwise, returns the
	 * string as the user entered it.
	 */
	public String getNombreEjecutable ( ) {
		return txtNombreEjecutable.getText( );
	}

	public DialogoNuevaCompilacion ( Dialog owner, String name, File dir ) {
		super(owner, TITULO_DIALOGO, true);
		
		init(name, dir);
	}
	public DialogoNuevaCompilacion ( Frame owner, String name, File dir ) {
		super(owner, TITULO_DIALOGO, true);
		
		init(name, dir);	
	}
	public DialogoNuevaCompilacion ( Window owner, String name, File dir ) {
		super(owner, TITULO_DIALOGO, Dialog.ModalityType.APPLICATION_MODAL );
		
		init(name, dir);	
	}
	private void init ( String name, File dir ) {

		this.directorioTrabajo = dir;

		txtNombreEjecutable.setText( name );
		lblDirectorioTrabajo.setText( this.directorioTrabajo.toString( ) );
		btnCambiarDT = new JButton( idiomas.getString( "eti_cambiarDTcompilacion" ) );
		btnCambiarDT.addActionListener( this );
		
		this.setResizable( true );
		
		// Handle window closing correctly.
		setDefaultCloseOperation( HIDE_ON_CLOSE );
	}

	public File getDirectorioTrabajo ( ) {
		return this.directorioTrabajo;
	}

	static public void main (String [] args) {
		DialogoNuevaCompilacion d = new DialogoNuevaCompilacion( new javax.swing.JFrame(), "hola", new File("/home") );
		d.showDialog();

	}

	public int showDialog ( ) {
		// Create an array of the text and components to be displayed.
		String strNombreEjecutable = idiomas.getString( "eti_nombreEjecutable" );
		String strDirectorioTrabajo = idiomas.getString( "eti_directorioTrabajo" );
		Object [] array = { strNombreEjecutable, txtNombreEjecutable,
				strDirectorioTrabajo, lblDirectorioTrabajo, btnCambiarDT };

		// Create an array specifying the number of dialog buttons
		// and their text.
		Object [] options = { cadbtnOK, cadbtnCancelar };

		// Create the JOptionPane.
		return JOptionPane.showOptionDialog( this.getParent( ) , array, TITULO_DIALOGO, JOptionPane.OK_CANCEL_OPTION ,
				JOptionPane.QUESTION_MESSAGE , null , options , options[0] );
	}


	public void actionPerformed( ActionEvent e ) {
		JDirectoryChooser dialogo = new JDirectoryChooser( new File("/") );
		dialogo.setSelectedDirectory( directorioTrabajo );
		if( dialogo.showDialog( this ) == JDirectoryChooser.OK_OPTION ) {
			this.directorioTrabajo = dialogo.getSelectedDirectory( );
			this.lblDirectorioTrabajo.setText( directorioTrabajo.toString( ) );
		}
		
	}
}
