package interfaz.vestadisticas.fuenteanotado;


import java.util.Enumeration;
import java.util.ResourceBundle;

import interfaz.vestadisticas.ColumnaTextoMultilineaTablaCellRenderer;
import interfaz.vestadisticas.CabeceraMultilineaTableCellRenderer;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EtchedBorder;
import javax.swing.table.TableColumn;

import modelo.modeloXML.InterfazModeloXML;
import modelo.vestadisticas.ModeloEstadistica;
import modelo.vestadisticas.fuenteanotado.ModeloListaFuentes;
import modelo.vestadisticas.fuenteanotado.ModeloTablaFuenteAnotado;
import net.miginfocom.swing.MigLayout;

public class JPanelFuenteAnotado extends JPanel implements InterfazModeloXML {

	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos");
	/**
	 * recursos de iconos etc...
	 */
	ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos");

	/************************PROPIEDADES***********************/
	/** serial version uid */
	private static final long serialVersionUID = 5036470445341444393L;

	
	protected ModeloTablaFuenteAnotado motabFuenteAnotado = new ModeloTablaFuenteAnotado();
	
	/** Tabla del panel del Fichero Fuente Anotado. Muestra todo el perfil plano del programa en filas y columnas. */
	protected JTable tabFuenteAnotado = new JTable();;
	{
		//para inicializar
		tabFuenteAnotado.setModel(motabFuenteAnotado);
		Enumeration < TableColumn > v =  tabFuenteAnotado.getColumnModel( ).getColumns( );
		while (v.hasMoreElements( ) )
			v.nextElement( ).setHeaderRenderer( new CabeceraMultilineaTableCellRenderer() );
		tabFuenteAnotado.setDefaultRenderer( String.class , new ColumnaTextoMultilineaTablaCellRenderer() );
		tabFuenteAnotado.setDefaultRenderer( Integer.class , new NumerosAnotadosCellRenderer() );
		
		//Política de cambio de tamaño.
		tabFuenteAnotado.setAutoResizeMode( JTable.AUTO_RESIZE_NEXT_COLUMN );
		tabFuenteAnotado.getColumnModel().getColumn( 0 ).setMinWidth( 15 );
		tabFuenteAnotado.getColumnModel().getColumn( 1 ).setMinWidth( 20 );
		tabFuenteAnotado.getColumnModel().getColumn( 2 ).setMinWidth( 15 );
		tabFuenteAnotado.getColumnModel().getColumn( 0 ).setPreferredWidth( 100 );
		tabFuenteAnotado.getColumnModel().getColumn( 1 ).setPreferredWidth( 100 );
		tabFuenteAnotado.getColumnModel().getColumn( 2 ).setPreferredWidth( 1000 );
		//tabFuenteAnotado.setMaximumSize( new Dimension(10000,10000) );

	}
	
	protected JScrollPane scrTabFuenteAnotado = new JScrollPane(tabFuenteAnotado, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	
/*	private class RedimensionadorTabFuenteAnotado implements TableModelListener {

		public void setAnchoColumnas(){        
		    JViewport scroll =  (JViewport) tabFuenteAnotado.getParent();
		    System.out.println(scroll.getWidth( ));
		    System.out.println(scroll.getBounds( ).getWidth( ));
		    System.out.println(scroll.getMaximumSize( ).getWidth( ));
		    System.out.println(scroll.getMinimumSize().getWidth( ));
		    System.out.println(scroll.getPreferredSize().getWidth( ));
		    System.out.println(scroll.getExtentSize( ).getWidth( ));
		    System.out.println(scroll.getViewSize( ).getWidth( ));
		    JScrollPane scroll2 = scrTabFuenteAnotado;
		    System.out.println(scroll2.getWidth( ));
		    System.out.println(scroll2.getBounds( ).getWidth( ));
		    System.out.println(scroll2.getMaximumSize( ).getWidth( ));
		    System.out.println(scroll2.getMinimumSize().getWidth( ));
		    System.out.println(scroll2.getPreferredSize().getWidth( ));
		    //System.out.println(scroll.getViewSize( ).getWidth( ));

		    int ancho = (int)scroll.getViewSize().getWidth(); 
		    int anchoColumna = 0; 
		    TableColumnModel modeloColumna = tabFuenteAnotado.getColumnModel(); 
		    TableColumn columnaTabla; 
		    for (int i = 0; i < tabFuenteAnotado.getColumnCount(); i++) { 
		        columnaTabla = modeloColumna.getColumn(i); 
		        switch(i){ 
		            case 1: anchoColumna = (30*ancho)/100; 
		                    break; 
		            case 2: anchoColumna = (50*ancho)/100; 
		                    break; 
		            case 3: anchoColumna = (20*ancho)/100; 
		                    break; 
		        }                      
		        columnaTabla.setPreferredWidth(anchoColumna);            
		    } 
		}  
		
		@Override
		public void tableChanged ( TableModelEvent arg0 ) {
			setAnchoColumnas();
			System.out.println("yes tableChanged");
			int maxLinea;
			TableModel m = tabFuenteAnotado.getModel( );
			if ( arg0.getSource( ) instanceof TableModel ) {
				m = (TableModel) arg0.getSource( );
				System.out.println("yes" );
			}
			Object c;
			
			*//**tamaño para número de línea: 
			* El mínimo será, el tamaño máximo de los contenidos.*//*
			maxLinea = 0;
			for ( int i = 0; i < m.getRowCount( ); i++ ){
				
				c = m.getValueAt( i , 0 );
				
				Font f = guigprof( ).getPreferencias( ).getFuenteAnotadoFont( );

				int stringWidth = (int) f.getStringBounds( c.toString( ) , new FontRenderContext(null, false, false) ).getWidth();
				
				maxLinea = Math.max( stringWidth , maxLinea );
			}
			maxLinea = maxLinea + 1;
			
			//tabFuenteAnotado.getColumnModel( ).getColumn(0).setMinWidth( maxLinea );
			tabFuenteAnotado.getColumnModel( ).getColumn(0).setPreferredWidth( maxLinea );
			
	
			*//**tamaño para número de ejecuciones: 
			* El mínimo será, el tamaño máximo de los contenidos.*//*
			maxLinea = 0;
			for ( int i = 0; i < m.getRowCount( ); i++ ){
				
				c = m.getValueAt( i , 0 );
				
				Font f = guigprof( ).getPreferencias( ).getFuenteAnotadoFont( );

				int stringWidth = (int) f.getStringBounds( c.toString( ) , new FontRenderContext(null, false, false) ).getWidth();
				
				maxLinea = Math.max( stringWidth , maxLinea );
			}
			maxLinea = maxLinea + 1;
			//tabFuenteAnotado.getColumnModel( ).getColumn(1).setMinWidth( maxLinea );
			tabFuenteAnotado.getColumnModel( ).getColumn(1).setPreferredWidth( maxLinea );
						
			*//**tamaño para las lineas: 
			* El mínimo será, el tamaño máximo de los contenidos.*//*
			//El ancho de la última línea será el máximo.
			
		}
	}
	
	RedimensionadorTabFuenteAnotado redimensionadorTabFuenteAnotado = new RedimensionadorTabFuenteAnotado();
	{
		motabFuenteAnotado.addTableModelListener( redimensionadorTabFuenteAnotado );
	}
*/

	/** */
	protected JLabel etiNombreFicheroFuente = new JLabel();
	{
		etiNombreFicheroFuente.setText( idiomas.getString( "eti_NombreFicheroFuenteElegido" ));
	}


	/**
	 * Modelo para ver la lista de ficheros/modulos.
	 */
	protected ModeloListaFuentes molisListaFuentes = new ModeloListaFuentes();/*
	
	
	/**
	 * ComboBox que sirve para elegir el fichero/modulo que se desea ver.
	 */
	protected JComboBox lisListaFuentes = new JComboBox();
	{
		lisListaFuentes.setModel( molisListaFuentes );
		lisListaFuentes.addActionListener( motabFuenteAnotado );
		lisListaFuentes.setRenderer( new NombreFicheroAnotadoCellRenderer() );
	}
	

	
	/** Etiqueta previa a la lista de fuentes. */
	protected JLabel etiListaFuentes = new JLabel();
	{
		etiListaFuentes.setText( idiomas.getString( "eti_ListaFuentes" ));
	}
	
	
	/************************CONSTRUCTOR***********************/
	/**
	 * Crea un panel estadistica de fuentes anotados a partir del ModeloXML 
	 * referenciado por <code>x<code>.
	 * @param _fichero Se supone que será un fichero fuente válido.
	 */
	public JPanelFuenteAnotado( ModeloEstadistica x ) {
		super(new MigLayout("insets 0, fill"));

		setDatosXML( x );
		
		addComponentes();
	}

	/**
	 * Crea un panel estadistica de fuentes anotados
	 */
	public JPanelFuenteAnotado() {
		super(new MigLayout("insets 0,fill"));

		addComponentes();

	}

	protected void addComponentes() {
		
		JPanel pnlFicheroAnotado;
		{
			pnlFicheroAnotado = new JPanel ( new MigLayout("") );
			pnlFicheroAnotado.add( etiNombreFicheroFuente , "sgy Cmd, split 2");
			pnlFicheroAnotado.add( lisListaFuentes , "gapbefore rel, growx  , pushx,wmin 100pt, sgy Cmd, wrap" );
			pnlFicheroAnotado.add( scrTabFuenteAnotado ,"grow, push, wrap");
			pnlFicheroAnotado.setBorder( BorderFactory.createEtchedBorder( EtchedBorder.LOWERED ) );
		}
		this.add( pnlFicheroAnotado , "grow" );
		
	}
	
	/************************METODOS***********************/


	@Override
	public void setDatosXML(ModeloEstadistica x) {

		motabFuenteAnotado.setDatosXML(x);
		
		molisListaFuentes.setDatosXML(x);
	}

}
