package interfaz.vestadisticas.fuenteanotado;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.ResourceBundle;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import negocio.PreferenciasSingleton;

public class NumerosAnotadosCellRenderer implements TableCellRenderer {

	static Integer				NUMERO_LINEA = new Integer (0);
	static Integer				EJECUCIONES = new Integer(1);
	
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	@Override
	public Component getTableCellRendererComponent ( JTable tabla ,
			Object valor , boolean seleccionado , boolean tieneElFoco ,
			int fila , int columna ) {
		
		Integer icolumna = new Integer( columna );
		JLabel resultado = new JLabel();

		
		if ( icolumna.equals( NUMERO_LINEA ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ).deriveFont(
					Font.BOLD ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setToolTipText( idiomas.getString( "ttp_linea" ) + " " + valor.toString( ) );
			resultado = x;
		} else if ( icolumna.equals( EJECUCIONES ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
					.getTableCellRendererComponent( tabla , valor ,
							seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ).deriveFont(
					Font.BOLD ) );
			x.setForeground( Color.WHITE );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setVerticalAlignment( SwingConstants.CENTER );
			if( ! x.getText( ).matches( "" )) {
				x.setBackground( Color.RED.darker( ) );
				x.setToolTipText( valor.toString( ) + " " + idiomas.getString( "ttp_ejecutada" ) );
			}
			else {
				x.setToolTipText( "0 " + idiomas.getString( "ttp_ejecutada" ) );
			}
			resultado = x;
		}
		
		return resultado;
	}

}
