package interfaz.vestadisticas.grafollamadas;

import java.awt.Component;
import java.util.ResourceBundle;

import javax.swing.JList;
import javax.swing.JTextPane;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;

import negocio.PreferenciasSingleton;

import modelo.modeloXML.Ciclo;
import modelo.modeloXML.EntradaFuncion;

public class FuncionListRenderer extends JTextPane implements ListCellRenderer {
	
	/** UID SERIAL VERSION*/
	private static final long	serialVersionUID	= 5679658297447485908L;
	
	/** recursos para dar soporte sobre idiomas */
	ResourceBundle							idiomas				= ResourceBundle
																		.getBundle( "interfaz.idiomas.Recursos" , 
																				PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de iconos etc... */
	ResourceBundle							recursos			= ResourceBundle
																		.getBundle( "interfaz.Recursos" , 
																				PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );

	@Override
	public Component getListCellRendererComponent ( JList list, Object objetoARenderer,
			int index, boolean selected, boolean cellHasFocus ) {
		
		this.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
		
		if ( objetoARenderer instanceof EntradaFuncion ) {
			EntradaFuncion e = (EntradaFuncion) objetoARenderer;
			this.setText( "[ " + e.getIndice( ) + " ] - " + e.getNombreFuncion() );
		} else if ( objetoARenderer instanceof Ciclo ) {
				Ciclo c = (Ciclo) objetoARenderer;
				this.setText( "[ " + c.getIndice( ) + " ] - " + idiomas.getString( "flr_ciclo" ) + " < " +
						c.getCiclo( ) + " > ");
			}
			else 			
				this.setText( objetoARenderer.toString() );
		
		
		if ( selected /*|| cellHasFocus*/ ) {
            setBackground( UIManager.getColor("List.selectionBackground") );
            setForeground( UIManager.getColor("List.selectionForeground") );
        } else {
            setBackground( UIManager.getColor("List.background") );
            setForeground( UIManager.getColor("List.fackground") );
        }
		
		return this;

	}

}
