package interfaz.vestadisticas.grafollamadas;

import java.awt.Component;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeCellRenderer;

import negocio.PreferenciasSingleton;

import modelo.modeloXML.Ciclo;
import modelo.modeloXML.EntradaFuncion;
import modelo.vestadisticas.grafollamadas.ModeloArbolGrafoLlamadas;

public class FuncionTreeRenderer extends JLabel implements TreeCellRenderer {

	/** serialVersion UID*/
	private static final long serialVersionUID = 241762804836842285L;

	public FuncionTreeRenderer () {
		setOpaque( true );
	}

	@Override
	public Component getTreeCellRendererComponent( JTree tree, Object objetoARenderer,
			boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {

		this.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
		
		if ( objetoARenderer instanceof DefaultMutableTreeNode ) {
			DefaultMutableTreeNode dn = (DefaultMutableTreeNode) objetoARenderer;
			Object obj = dn.getUserObject();
			if ( obj instanceof EntradaFuncion) {
				EntradaFuncion e = (EntradaFuncion) obj;
				this.setText( "[ " + e.getIndice( ) + " ] - " + e.getNombreFuncion() );
				
				/** Color. resaltado. */
				if ( tree.getModel( ) instanceof ModeloArbolGrafoLlamadas ) {
					EntradaFuncion ef = ( ( ModeloArbolGrafoLlamadas ) tree.getModel( ) ).getFuncionActivo( );
					Ciclo c = ( ( ModeloArbolGrafoLlamadas ) tree.getModel( ) ).getCicloActivo( );
					if ( ef != null ) {
						if ( e.getIndice( ) == ef.getIndice( ) )
							selected = true;
						else
							selected = false;
					}
					else if ( c != null ) {
						if( e.getCiclo( ) != null ) {
							if ( e.getCiclo( ).getCiclo( ) == c.getCiclo( ) )
						//if ( e.getCiclo( ).equals( c ) )
								selected = true;
							else
								selected = false;
						}
						else
							selected = false;
					}
				}
			}
			else {
				this.setText( obj.toString() );
			}
			
		} else {
			this.setText( objetoARenderer.toString() );
		}
		
		//TODO aquí tengo que hacer el renderer completo del árbol :D
		
	    //selectionBorderColor = UIManager.getColor("Tree.selectionBorderColor");
	    //textForeground = UIManager.getColor("Tree.textForeground");
	    //textBackground = UIManager.getColor("Tree.textBackground");
		
		if ( selected || hasFocus ) {
            setBackground( UIManager.getColor("Tree.selectionBackground") );
            setForeground( UIManager.getColor("Tree.selectionForeground") );
        }/* if ( cellHasFocus ) {
        	setBackground(  UIManager.getColor("List.selectionBackground") );//list.getSelectionBackground());
            setForeground(Color.BLUE);//list.getSelectionForeground());
        }*/ else {
            setBackground( UIManager.getColor("Tree.background") );
            setForeground( UIManager.getColor("Tree.fackground") );
        }/*if (selected) {
            setBackground( UIManager.getColor("Tree.selectionBackground") );
            setForeground( UIManager.getColor("Tree.selectionForeground") );
        } else {
            setBackground( tree.getBackground() );
            setForeground( tree.getForeground() );
        }*/

		return this;
	}

}
