package interfaz.vestadisticas.perfilplano;

import java.awt.Dimension;
import java.util.Enumeration;
import java.util.ResourceBundle;


import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.table.TableColumn;
//import javax.swing.JTextArea;


import interfaz.grafico.JGrafico;
import interfaz.vestadisticas.ColumnaTextoMultilineaTablaCellRenderer;
import interfaz.vestadisticas.CabeceraMultilineaTableCellRenderer;

import modelo.modeloXML.InterfazModeloXML;
import modelo.vestadisticas.ModeloEstadistica;
import modelo.vestadisticas.perfilplano.ModeloGraficoPerfilPlano;
import modelo.vestadisticas.perfilplano.ModeloTablaPerfilPlano;
import net.miginfocom.swing.MigLayout;

public class JPanelPerfilPlano extends JPanel implements InterfazModeloXML {
	/** **********************PROPIEDADES********************** */
	/** serial version uid */
	private final static long serialVersionUID = 1;

	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos");
	
/*	*//**
	 * Botón del panel del Perfil Plano. Al pulsar este botón se abre un diálogo
	 * para aplicar filtros a la tabFuenteAnotado.
	 *//*
	private JButton botFiltro = new JButton();
	{// falta inicializar correctamente
		botFiltro.setText( idiomas.getString("bot_filtro") );
		botFiltro.setToolTipText( idiomas.getString("bot_filtro") );
		botFiltro.setMinimumSize(new Dimension(30, 30));
		botFiltro.setPreferredSize(new Dimension(80, 30));
	}

	*//**
	 * Botón del panel del Perfil Plano. Al pulsar este botón se abre un diálogo
	 * para buscar funciones concretas en la tabFuenteAnotado.
	 *//*
	private JButton botBusqueda = new JButton("");
	{// falta inicializar correctamente
		botBusqueda.setText( idiomas.getString("bot_buscar") );
		botBusqueda.setToolTipText( idiomas.getString("bot_buscar") );
		botBusqueda.setMinimumSize(new Dimension(30, 30));
		botBusqueda.setPreferredSize(new Dimension(80, 30));
	}

	*//**
	 * Botón del panel del Perfil Plano. Al pulsar este botón se abre un diálogo
	 * para configurar el gráfico.
	 *//*
	private JButton botConfigurarGrafico = new JButton();
	{// falta inicializar correctamente
		botConfigurarGrafico.setText( idiomas.getString("bot_configurar") );
		botConfigurarGrafico.setToolTipText( idiomas.getString("bot_configurar") );
		botConfigurarGrafico.setMinimumSize(new Dimension(30, 30));
		botConfigurarGrafico.setPreferredSize(new Dimension(80, 30));
	}
*/
	
	private ModeloGraficoPerfilPlano modGraPorcentajesFunciones = new ModeloGraficoPerfilPlano();
	
	/**
	 * Gráfico del panel del Perfil Plano. En él se muestran los porcentajes de
	 * tiempos de las funciones más interesantes. Al pulsar este gráfico se abre
	 * un diálogo para configurarlo.
	 */
	private JGrafico graPorcentajesFunciones = new JGrafico();// falta inicializar
															// correctamente
	{
		graPorcentajesFunciones.setModel( modGraPorcentajesFunciones );
	}

	private JLabel etiPorcentajesFunciones = new JLabel();
	{
		etiPorcentajesFunciones.setText( idiomas.getString( "eti_porcentajes" ) );
	}

	/**
	 * Etiqueta del panel del Perfil Plano. Muestra el tiempo que hay entre una
	 * muestra y otra, el periódo.
	 */
/*	private JTextArea atxPeriodoMuestra = new JTextArea();
	{
		atxPeriodoMuestra.setText("El error es de " + "<error>"
				+ ", el periodo es de " + "<periodo>"
				+ " y el tiempo total de ejecución es de " + "<total>");// falta
																		// inicializar
																		// correctamente
		atxPeriodoMuestra.setEditable( false );
		atxPeriodoMuestra.setWrapStyleWord( true );
		atxPeriodoMuestra.setLineWrap( true );
		atxPeriodoMuestra.setOpaque( false );
	}*/

	/*
	 * Etiqueta del panel del Perfil Plano. Muestra lo lista de la función
	 * seleccionada. public JLabel seleccionada;
	 */// puede que no se ponga finalmente... la
									// dejo provisionalmente aquí comentada.
	
	private ModeloTablaPerfilPlano modTabPerfilPlano = new ModeloTablaPerfilPlano ();
	
	/**
	 * Tabla del panel del Perfil Plano. Muestra todo el perfil plano del
	 * programa en filas y columnas.
	 */
	private JTable tabPerfilPlano = new JTable();
	{
		tabPerfilPlano.setModel( modTabPerfilPlano );
		
		//renderers
		Enumeration < TableColumn > v =  tabPerfilPlano.getColumnModel( ).getColumns( );
		while (v.hasMoreElements( ) ) {
			v.nextElement( ).setHeaderRenderer( new CabeceraMultilineaTableCellRenderer() );
		}
		tabPerfilPlano.setDefaultRenderer( String.class , new ColumnaTextoMultilineaTablaCellRenderer() );
		tabPerfilPlano.setDefaultRenderer( Integer.class , new TabPPCellRenderer() );
		tabPerfilPlano.setDefaultRenderer( Double.class , new TabPPCellRenderer() );
		
		//Política de cambio de tamaño.
		tabPerfilPlano.setAutoResizeMode( JTable.AUTO_RESIZE_NEXT_COLUMN );
		tabPerfilPlano.getColumnModel().getColumn( 0 ).setMinWidth( 20 );
		tabPerfilPlano.getColumnModel().getColumn( 1 ).setMinWidth( 10 );
		tabPerfilPlano.getColumnModel().getColumn( 2 ).setMinWidth( 10 );
		tabPerfilPlano.getColumnModel().getColumn( 3 ).setMinWidth( 10 );
		tabPerfilPlano.getColumnModel().getColumn( 4 ).setMinWidth( 7 );
		tabPerfilPlano.getColumnModel().getColumn( 5 ).setMinWidth( 10 );
		tabPerfilPlano.getColumnModel().getColumn( 6 ).setMinWidth( 10 );
		tabPerfilPlano.getColumnModel().getColumn( 0 ).setPreferredWidth( 100 );
		tabPerfilPlano.getColumnModel().getColumn( 1 ).setPreferredWidth( 30 );
		tabPerfilPlano.getColumnModel().getColumn( 2 ).setPreferredWidth( 50 );
		tabPerfilPlano.getColumnModel().getColumn( 3 ).setPreferredWidth( 50 );
		tabPerfilPlano.getColumnModel().getColumn( 4 ).setPreferredWidth( 20 );
		tabPerfilPlano.getColumnModel().getColumn( 5 ).setPreferredWidth( 50 );
		tabPerfilPlano.getColumnModel().getColumn( 6 ).setPreferredWidth( 50 );
	}
		//tabPerfilPlano.setPreferredScrollableViewportSize(new Dimension(400,
		//		400)); // es el tamaño por defecto del scroll, que si no se
						// haría lo mínimo

	/** **********************CONSTRUCTOR********************** */
	/**
	 * Crea un panel estadistica de perfil plano, con el fichero fuente de gprof
	 * referenciado por <code>_fichero<code>.
	 * @param _fichero Se supone que será un fichero fuente válido.
	 */
	public JPanelPerfilPlano ( ModeloEstadistica x ) {
		super( new MigLayout( "insets 0, fill" ) );

		setDatosXML( x );
		
		addComponentes();
	}

	/**
	 * Crea un panel estadistica de perfil plano, con el fichero fuente de gprof
	 * referenciado por <code>_fichero<code>.
	 * @param _fichero Se supone que será un fichero fuente válido.
	 */
	public JPanelPerfilPlano () {
		super( new MigLayout( "insets 0, fill" ) );
		
		addComponentes();
	}

	protected void addComponentes() {
		// crear el panel:

		// crear split pane (panel principal)
		JSplitPane splitpane = new JSplitPane( JSplitPane.VERTICAL_SPLIT );
		// añadir split pane
		add( splitpane, "grow" );

		// crear componente izquierdo
		JPanel panelizquierdo = new JPanel( new MigLayout( "inset panel, fill" ) );

		/*
		 * JScrollPane scrollpane=new JScrollPane(tabPerfilPlano);
		 * scrollpane.setMinimumSize(new Dimension(100,100));
		 * scrollpane.setPreferredSize(new Dimension(400,400));
		 */
		panelizquierdo.add( new JScrollPane( tabPerfilPlano ), "grow, push" );

		// crear componente derecho
		JPanel panelderecho = new JPanel( new MigLayout( "inset panel, fill" ) );

		panelderecho.add( etiPorcentajesFunciones, "wrap" );
		panelderecho.add( graPorcentajesFunciones, "growx,growy 75,wrap" );// dos
																			// casillas
//		panelderecho.add( new JScrollPane( atxPeriodoMuestra ),
//				"wrap, growx,growy 25");
/*		panelderecho.add( botFiltro, "split 3,growx, sizegroup botones" );
		panelderecho.add( botBusqueda, "growx, sizegroup botones" );
		panelderecho.add( botConfigurarGrafico, "growx, sizegroup botones" );*/

		// añadir componente izquierdo al split
		splitpane.setLeftComponent( panelizquierdo );
		// añadir componente derecho al split
		splitpane.setRightComponent( panelderecho );

		// Propiedades al splitpane
		// Tamañs mínimos para los componenetes
		Dimension tamañoMinimo = new Dimension( 150, 150 );
		panelizquierdo.setMinimumSize( tamañoMinimo );
		panelderecho.setMinimumSize( tamañoMinimo );
		// Tamaño de la barra divisora
		splitpane.setDividerSize( 8 );
		// Que se pueda expandir y contraer
		splitpane.setOneTouchExpandable( true );
	}

	/** **********************METODOS********************** */


	@Override
	public void setDatosXML(ModeloEstadistica x) {

		modTabPerfilPlano.setDatosXML( x );
		modGraPorcentajesFunciones.setDatosXML( x );
		
	}

}
