package interfaz.vestadisticas.perfilplano;

import java.awt.Component;
import java.util.ResourceBundle;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import negocio.PreferenciasSingleton;

public class TabPPCellRenderer implements TableCellRenderer {

	static Integer				NOMBRE = new Integer (0);
	static Integer				PORCENTAJE = new Integer(1);
	static Integer				TPROPIO = new Integer (2);
	static Integer				TACUMULADO = new Integer(3);
	static Integer				LLAMADAS = new Integer (4);
	static Integer				TPROPIOXLLAMADAS = new Integer(5);
	static Integer				TTOTALXLLAMADAS = new Integer (6);
	
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	@Override
	public Component getTableCellRendererComponent ( JTable tabla ,
			Object valor , boolean seleccionado , boolean tieneElFoco ,
			int fila , int columna ) {
		
		Integer icolumna = new Integer( columna );
		JLabel resultado = new JLabel();
		
		//DecimalFormat formateadorS = new DecimalFormat("###,##0.00 s");

		
		if ( icolumna.equals( PORCENTAJE ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
				/** Sólo 2 decimales + porcentaje */
			Double d = Double.parseDouble( x.getText( ) );
			x.setText( String.format("%1$,6.2f %2$1s",d*100, "%" ) );
			x.setToolTipText( idiomas.getString( "ttp_porcentaje" ) );
			resultado = x;
		} else if ( icolumna.equals( TPROPIO ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//x.setText( formateadorS.format( d ) );
				x.setText( String.format( "%1$,8.2f s", d ) );
				//x.setText( x.getText( ) + " s" );
			}
			x.setToolTipText( idiomas.getString( "ttp_tpropio" ) );
			resultado = x;
		}  else if ( icolumna.equals( TACUMULADO ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//x.setText( formateadorS.format( d ) );
				x.setText( String.format( "%1$,8.2f s", d ) );
				//x.setText( x.getText( ) + " s" );
			}
			x.setToolTipText( idiomas.getString( "ttp_tacumulado" ) );
			resultado = x;
		} else if ( icolumna.equals( LLAMADAS  ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			x.setToolTipText( idiomas.getString( "ttp_llamadas" ) );
			resultado = x;
		} else if ( icolumna.equals( TPROPIOXLLAMADAS ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//x.setText( formateadorS.format( d ) );
				x.setText( String.format( "%1$,8.2f ms", d ) );
				//x.setText( x.getText( ) + " s" );
			}
			x.setToolTipText( idiomas.getString( "ttp_tpropioxllamada" ) );
			resultado = x;
		} else if ( icolumna.equals( TTOTALXLLAMADAS ) ) {
			JLabel x = (JLabel) new DefaultTableCellRenderer( )
			.getTableCellRendererComponent( tabla , valor ,
					seleccionado , tieneElFoco , fila , columna );
			x.setFont( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getEstadisticasFont( ) );
			x.setHorizontalAlignment( SwingConstants.CENTER );
			if( !x.getText( ).equals( "" )) {
				/** Sólo 2 decimales */
				Double d = Double.parseDouble( x.getText( ) );
				//x.setText( formateadorS.format( d ) );
				x.setText( String.format( "%1$,8.2f ms", d ) );
				//x.setText( x.getText( ) + " s" );
			}
			x.setToolTipText( idiomas.getString( "ttp_ttotalxllamada" ) );
			resultado = x;
		}
		
		return resultado;
	}
}
