package interfaz.vgprof;

import interfaz.dialogos.dialogoAbrir.DialogoAbrir;
import interfaz.dialogos.dialogoDirectorio.JDirectoryChooser;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import net.miginfocom.swing.MigLayout;

public class DialogoGenerarGprof  extends JDialog {

	/** serial Version UID */
	private static final long	serialVersionUID	= -2201823396167528830L;
	/**
	 * recursos para dar soporte sobre idiomas
	 */
	ResourceBundle					idiomas				= ResourceBundle
																.getBundle( "interfaz.idiomas.Recursos" );
	/**
	 * recursos de iconos etc...
	 */
	ResourceBundle					recursos			= ResourceBundle
																.getBundle( "interfaz.Recursos" );

	public static final int	OK_OPTION	= JOptionPane.OK_OPTION;
	public static final int CANCEL_OPTION = JOptionPane.CANCEL_OPTION;

	
	private JTextField	txtNombreGprof		= new JTextField(50);
	private File 		directorioTrabajo	= null;
	private File		archivoDatos		= null;
	private File		programa			= null;
	
	private JTextField		txtDirectorioTrabajo	= new JTextField();
	private JTextField		txtArchivoDatos		= new JTextField();
	private JTextField		txtPrograma			= new JTextField();
	
	private JButton		btnCambiarDT		= null;
	private JButton		btnCambiarADatos	= null;
	private JButton		btnCambiarPrograma	= null;
	
	private String		cadbtnOK	= idiomas.getString( "eti_botOk" );
	private String		cadbtnCancelar	= idiomas.getString( "eti_botCancelar" );
	
	private String		titulo;

	
	
	public DialogoGenerarGprof ( String nombreSalidaGprof , File prog, File gmon, File dir ) {
		super();

		this.directorioTrabajo = dir;
		this.archivoDatos = gmon;
		this.programa = prog;
		this.txtNombreGprof.setText( nombreSalidaGprof );

		this.titulo = ( idiomas.getString( "eti_titulo_dialogo_generarGprof" ) );

		this.txtArchivoDatos.setEditable( false );
		this.txtDirectorioTrabajo.setEditable( false );
		this.txtPrograma.setEditable( false );
		
		final JDialog this_dialog = this;
		
		if ( directorioTrabajo != null ) txtDirectorioTrabajo.setText( this.directorioTrabajo.toString( ) );
		else txtDirectorioTrabajo.setText( new String("") );
		//btnCambiarDT = new JButton( idiomas.getString( "eti_cambiarDTgprof" ) );
		btnCambiarDT = new JButton( "..." );
		btnCambiarDT.addActionListener( new ActionListener () {
			public void actionPerformed( ActionEvent e ) {
				JDirectoryChooser dialogo = new JDirectoryChooser( new File("/") );
				dialogo.setSelectedDirectory( directorioTrabajo );
				if( dialogo.showDialog( this_dialog ) == JDirectoryChooser.OK_OPTION ) {
					directorioTrabajo = dialogo.getSelectedDirectory( );
					txtDirectorioTrabajo.setText( directorioTrabajo.toString( ) );
				}
				
			}

		});
		
		if (archivoDatos != null) txtArchivoDatos.setText( this.archivoDatos.toString( ) );
		else txtArchivoDatos.setText( new String("") );
		//btnCambiarADatos = new JButton( idiomas.getString( "eti_editarDatosEjecucionGprof" ) );
		btnCambiarADatos = new JButton( "..." );
		btnCambiarADatos.addActionListener( new ActionListener () {
			public void actionPerformed( ActionEvent e ) {
				DialogoAbrir dialogoAbrir = new DialogoAbrir();
				if ( directorioTrabajo != null) dialogoAbrir.setCurrentDirectory( directorioTrabajo );
				if( dialogoAbrir.showOpenDialogSalida( this_dialog, false ) == JFileChooser.APPROVE_OPTION ) {
					archivoDatos = dialogoAbrir.getSelectedFile( );
					if (archivoDatos != null) {
						txtArchivoDatos.setText( archivoDatos.toString( ) );
					}
				}
			}

		});
		
		if ( programa != null ) txtPrograma.setText( this.programa.toString( ) );
		else txtPrograma.setText( new String("") );
		//btnCambiarPrograma = new JButton( idiomas.getString( "eti_editarProgramaGprof" ) );
		btnCambiarPrograma = new JButton( "..." );
		btnCambiarPrograma.addActionListener( new ActionListener () {
			public void actionPerformed( ActionEvent e ) {
				DialogoAbrir dialogoAbrir = new DialogoAbrir();
				if ( directorioTrabajo != null) dialogoAbrir.setCurrentDirectory( directorioTrabajo );
				if( dialogoAbrir.showOpenDialogEjecucion( this_dialog, false ) == JFileChooser.APPROVE_OPTION && dialogoAbrir.getSelectedFile( ) != null ) {
					programa = dialogoAbrir.getSelectedFile( );
					if (programa != null) txtPrograma.setText( programa.toString( ) );
				}	
			}

		});
		
		this.setResizable( true );
		
		// Handle window closing correctly.
		setDefaultCloseOperation( HIDE_ON_CLOSE );
	}

	public int showDialog ( Component parent ) {
		// Create an array of the text and components to be displayed.
		/*String strNombreGprof = idiomas.getString( "eti_nombreGprof" );
		String strNombrePrograma = idiomas.getString( "eti_nombreProgramaGprof" );
		String strNombreArchivoDatos = idiomas.getString( "eti_nombreArchivoDatos" );
		String strDirectorioTrabajo = idiomas.getString( "eti_directorioTrabajo" );*/
		
		JLabel strNombreGprof = new JLabel ( idiomas.getString( "eti_nombreGprof" ) );
		JLabel strNombrePrograma = new JLabel ( idiomas.getString( "eti_nombreProgramaGprof" ) );
		JLabel strNombreArchivoDatos = new JLabel ( idiomas.getString( "eti_nombreArchivoDatos" ) );
		JLabel strDirectorioTrabajo = new JLabel ( idiomas.getString( "eti_directorioTrabajo" ) );
		
		JPanel pnlDialog = new JPanel( new MigLayout ( "fill" ));
		pnlDialog.add( strNombreGprof , "sgy Cmd");
		pnlDialog.add( this.txtNombreGprof , "growx,pushx,wmin 100pt, sgy Cmd, wrap" );
		pnlDialog.add( strNombrePrograma , "sgy Cmd");
		pnlDialog.add( this.txtPrograma , "growx,pushx,wmin 100pt, sgy Cmd" );
		pnlDialog.add( this.btnCambiarPrograma , "sgy Cmd, wrap" );
		pnlDialog.add( strNombreArchivoDatos , "sgy Cmd");
		pnlDialog.add( this.txtArchivoDatos , "growx,pushx,wmin 100pt, sgy Cmd" );
		pnlDialog.add( this.btnCambiarADatos , "sgy Cmd, wrap" );
		pnlDialog.add( strDirectorioTrabajo , "sgy Cmd");
		pnlDialog.add( this.txtDirectorioTrabajo , "growx,pushx,wmin 100pt, sgy Cmd," );
		pnlDialog.add( this.btnCambiarDT , "sgy Dir, wrap" );

		/*Object [] array = { strNombreGprof, txtNombreGprof, strNombrePrograma,
				txtPrograma, btnCambiarPrograma, strNombreArchivoDatos, txtArchivoDatos,
				btnCambiarADatos, strDirectorioTrabajo, txtDirectorioTrabajo, 
				btnCambiarDT };*/
		Object [] array = { pnlDialog };

		// Create an array specifying the number of dialog buttons
		// and their text.
		Object [] options = { cadbtnOK, cadbtnCancelar };

		// Create the JOptionPane.
		return JOptionPane.showOptionDialog( parent , array, titulo, JOptionPane.OK_CANCEL_OPTION ,
				JOptionPane.QUESTION_MESSAGE , null , options , options[0] );
	}

	static public void main (String [] args) {
		DialogoGenerarGprof d = new DialogoGenerarGprof( "hola", null, null, new File("/home") );
		d.showDialog(new javax.swing.JFrame());

	}
	
	public String getNombreNuevo ( ) {
		return this.txtNombreGprof.getText();
	}

	public File getPrograma ( ) {
		return this.programa;
	}

	public File getArchivoDatos ( ) {
		return this.archivoDatos;
	}

	public File getDirectorioTrabajo ( ) {
		return this.directorioTrabajo;
	}
}
