package interfaz.vgprof;

import interfaz.Vista;
import interfaz.acciones.CrearYGestionarAcciones;
import interfaz.acciones.InterfazAbrirDatosEjecucion;
import interfaz.acciones.InterfazCambiarDirectorioTrabajo;
import interfaz.acciones.InterfazCambiarNombre;
import interfaz.dialogos.dialogoAbrir.DialogoAbrir;
import interfaz.dialogos.dialogoCambiarComando.DialogoCambiarComando;
import interfaz.dialogos.dialogoDirectorio.JDirectoryChooser;
import interfaz.dialogos.error.DialogoError;

import java.awt.Component;
import java.awt.Font;
import java.awt.Frame;
import java.io.File;

import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.vejecucion.ModeloEjecucion;
import modelo.vgprof.ModeloGprof;
import negocio.PreferenciasSingleton;
import negocio.guigprof;
import negocio.ejecutarOrdenes.EjecutorComandos;
import net.miginfocom.swing.MigLayout;

/**
 * @author angel2
 *
 */
public class VistaGprof  extends JPanel implements Vista , InterfazAbrirDatosEjecucion,
	InterfazCambiarNombre, InterfazCambiarDirectorioTrabajo {

	/** serial version UID */
	private static final long serialVersionUID = 7934067204858477027L;

	/** Esta es la clase principal, ventana principal del interfaz o gui. */
	private Frame gui;
	
	/** recursos para dar soporte sobre idiomas */
	static ResourceBundle idiomas = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de iconos etc... */
	static ResourceBundle recursos = ResourceBundle.getBundle("interfaz.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	/** recursos de idiomas para errores */
	static ResourceBundle errores = ResourceBundle.getBundle("interfaz.errores.Errores", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	/** dialogo Abrir **/ 
	DialogoAbrir					dialogoAbrir		= new DialogoAbrir( );
	
	/** barra de tareas específica de esta vista. */
	JToolBar barraDeTareas = new JToolBar();
	
	/**********Constructor PANEL Y GESTION PANEL***************/
	
	/**
	 * @param guIguigprof
	 */
	public VistaGprof ( Frame gui ) {
		super(new MigLayout("fill"));
		this.gui = gui;
		crearPanel();
		crearBarraTareas();
	}

	/** Panel general de la vista compilación */
//	private JPanel panel;
	/** Panel de pestañas inferior, donde se muestra la salida de la compilación */
	private JTabbedPane	pestañas	= new JTabbedPane( );
	{
		ChangeListener cambioPestaña = new ChangeListener () {

			@Override
			public void stateChanged ( ChangeEvent arg0 ) {
				activarActions(visible);
			}
			
		};
		pestañas.addChangeListener( cambioPestaña );
	}

	protected void crearBarraTareas() {
/*		JButton botAbrirSalidaGprof = new JButton ();
		{
			botAbrirSalidaGprof.setHideActionText(true);
			botAbrirSalidaGprof.setAction(CrearYGestionarAcciones.getInstance().getAccionAbrirSalidaGprof( ) );
		}*/
		JButton botGenerarSalidaGprof = new JButton ();
		{
			botGenerarSalidaGprof.setHideActionText(true);
			botGenerarSalidaGprof.setAction(CrearYGestionarAcciones.getInstance().getAccionAbrirDatosEjecucion( ) );
		}
		JButton botCerrar = new JButton ();
		{
			botCerrar.setHideActionText(true);
			botCerrar.setAction(CrearYGestionarAcciones.getInstance().getAccionCerrar());
		}
		JButton botGprof = new JButton ();
		{
			botGprof.setHideActionText(true);
			botGprof.setAction(CrearYGestionarAcciones.getInstance().getAccionGprof( ) );
		}
		JButton botNombre = new JButton ();
		{
			botNombre.setHideActionText(true);
			botNombre.setAction( CrearYGestionarAcciones.getInstance().getAccionNombreSalida( ) );
		}
		JButton botPasarLeerXML = new JButton ();
		{
			botPasarLeerXML.setHideActionText(true);
			botPasarLeerXML.setAction( CrearYGestionarAcciones.getInstance().getAccionPasarAXML() );
		}
		{
			barraDeTareas.setAutoscrolls(true);
			barraDeTareas.setFloatable(false);
/*			barraDeTareas.add(botAbrirSalidaGprof);*/
			barraDeTareas.add(botGenerarSalidaGprof);
			barraDeTareas.add( botCerrar );
			barraDeTareas.addSeparator( );
			barraDeTareas.add( botNombre );
			barraDeTareas.add( botGprof );
			barraDeTareas.addSeparator( );
			barraDeTareas.add(botPasarLeerXML );
		}
	}

	/**
	 * @return
	 */
	public JToolBar getBarraDeTareas() {
		return barraDeTareas;
	}
	
	protected void crearPanel () {
		/*Aquí hay que hacer el panel*/
		setOpaque(true);

		/* Se añade las pestañas. */
		add(pestañas, "grow");
		
		/* A continuación, se crea un panel inicial vacío. */
		pestañas.addTab( "" , new JPanelGprof( null ) );
	}
	
	protected void añadirPestaña( ModeloGprof mg ) {
		String nombreSalidaGprof = mg.getNombreSalidaGprof( );

		if ( mg.getNombreSalidaGprof( ) == null ) {
			nombreSalidaGprof = getNuevoNombre();
			if ( mg.getArchivoDatos( ) != null ) {
				String nombre = mg.getArchivoDatos( ).getName( ).substring( 0, 
						mg.getArchivoDatos( ).getName().lastIndexOf( '.' ) );
				nombreSalidaGprof = nombre;
			}
		}

		Icon icon = (Icon) recursos.getObject( "icn_Gprof" );
		
		JPanelGprof pestañaNueva = new JPanelGprof ( mg );
		
		/** Crear la pestaña correctamente */
		pestañas.addTab(nombreSalidaGprof, pestañaNueva);
		int index = pestañas.indexOfComponent(pestañaNueva);

		javax.swing.JLabel tabRenderer = new javax.swing.JLabel ( nombreSalidaGprof );
		tabRenderer.setIcon(icon);
		tabRenderer.setIconTextGap(5);
		tabRenderer.setHorizontalTextPosition(SwingConstants.RIGHT);
		//tabRenderer.setToolTipText(camino);
				
		pestañas.setTabComponentAt(index, tabRenderer);
		pestañas.setToolTipTextAt(index, nombreSalidaGprof);
		
		pestañas.setSelectedComponent(pestañaNueva);
	}
	
	/*********** métodos *************/
/*
	public String getNuevoNombre( ) {
		return idiomas.getString( "nombreEstandarCompilacion" ) + "_" + ( pestañas.getTabCount( ) + 1 );
	}*/
	
	public void cerrarPestañaActiva () {
		//		Programar un trabajo para el hilo de despacho
		final int indicePestañaActiva = pestañas.getSelectedIndex();
		if (indicePestañaActiva != -1) {
			//usar el propiedades para estos comentarios...
			String cuestión= new String(idiomas.getString("eti_gprof_seguroCerrar"));
			String título= new String(idiomas.getString("eti_cerrar"));
			int está_usted_seguro= JOptionPane.showConfirmDialog(gui,
					cuestión,
					título,
					JOptionPane.YES_NO_OPTION);

			if(está_usted_seguro==JOptionPane.YES_OPTION){
				if( pestañas.getTabCount( ) > 1 ) {
					pestañas.removeTabAt(indicePestañaActiva);
					
				} else if( pestañas.getTabCount() == 1 ) {
					pestañas.removeAll( );
					pestañas.add( new JPanelGprof ( ) );
				}
			}
		}
	}
	
	public void cerrarTodo ( ) {
		pestañas.removeAll( );
	}
	
/*	public void generarGprof ( ) {
		
		String nombre_salidaGprof = getNuevoNombre( );
		File dir = guigprof( ).getPreferencias( ).getWorkspaceGprof( );
		DialogoGenerarGprof dialog = new DialogoGenerarGprof( nombre_salidaGprof, null, null, dir );
		if( dialog.showDialog( gui ) == DialogoGenerarGprof.OK_OPTION ) {
			ModeloGprof mg = new ModeloGprof();
			
			File prog = null;
			if( dialog.getPrograma( ) != null ) {
				prog = dialog.getPrograma( );
			}
			mg.setPrograma( prog );
			
			File gmon = null;
			if( dialog.getArchivoDatos( ) != null ) {
				if ( dialog.getNombreNuevo().equals( nombre_salidaGprof ) ) {
					*//** Si hay un archivo de datos, el futuro nombre de la salida lo tomará de él.*//*
					mg.setNombreSalidaGprof( gmon.getName( ).substring( 0, gmon.getName().lastIndexOf( '.' ) ) );
				}
				else {
					if( dialog.getNombreNuevo( ).length( ) > 0 ) {
						nombre_salidaGprof = dialog.getNombreNuevo( );
					}
					mg.setNombreSalidaGprof( nombre_salidaGprof );
				}
				gmon = dialog.getArchivoDatos( );
			}
			else {
				if( dialog.getNombreNuevo( ).length( ) > 0 ) {
					nombre_salidaGprof = dialog.getNombreNuevo( );
				}
				mg.setNombreSalidaGprof( nombre_salidaGprof );
			}
			mg.setArchivoDatos( gmon );

			if( dialog.getDirectorioTrabajo( ) != null ) {
				dir = dialog.getDirectorioTrabajo( );
			}
			mg.setDirectorioTrabajo( dir );
			
			abrirSalidaGprof( mg );
			}
		}
	}*/

	private String getNuevoNombre ( ) {
		return idiomas.getString( "nombreEstandarGprof" ) + "_" + ( pestañas.getTabCount( ) );
	}

	public void abrirDatosEjecucion ( ModeloGprof mg ) {

		if ( mg != null ) {
			if ( pestañas.getTabCount( ) == 1
					&& pestañas.getComponentAt( 0 ) instanceof JPanelGprof
					&& ( (JPanelGprof) pestañas.getComponentAt( 0 ) )
							.isVacio( ) ) {
				pestañas.removeAll( );
				añadirPestaña( mg );
			} else {
				añadirPestaña( mg );
			}
		}
	}

	public void abrirDatosEjecucion ( ModeloEjecucion mj ) {
		ModeloGprof mg = new ModeloGprof();
		mg.setDirectorioTrabajo( mj.getDirectorioTrabajo( ) );
		File prog = mj.getPrograma( );
		if ( prog != null && prog.exists( ) ) {
			mg.setPrograma( prog );
			if ( mj.getFicheroResultados( ) != null && mj.getFicheroResultados( ).exists( ) ) {
				mg.setArchivoDatos( mj.getFicheroResultados( ) );
			}
			else {
				DialogoError.getInstance( ).showErrorDialog( 
						errores.getString( "err_abrirGprof-no-gmon" ) );						
			}
			this.abrirDatosEjecucion( mg );
		} else {
			DialogoError.getInstance( ).showErrorDialog(  
					errores.getString( "err_abrirGprof-no-programa" ) );
		}

	}

	public void editarProgramaGprof ( ) {
		File dir = this.getModeloGprofActivo( ).getDirectorioTrabajo( );
		if ( dir != null) dialogoAbrir.setCurrentDirectory( dir );
		if( dialogoAbrir.showOpenDialogEjecucion( guigprof.getInstance( ).getGUI( ), false ) == JFileChooser.APPROVE_OPTION && dialogoAbrir.getSelectedFile( ) != null ) {
			this.editarPrograma( dialogoAbrir.getSelectedFile( ) );
		}
	}

	public void abrirDatosEjecucion ( ) {
		ModeloGprof mg = new ModeloGprof();
		File archivoDatos = null;
		/** Mostrar el dialogo de abrir (DialogoAbrir). */
		if ( dialogoAbrir.showOpenDialogSalida( guigprof.getInstance( ).getGUI( ), false ) == JFileChooser.APPROVE_OPTION ) {
			
			archivoDatos = dialogoAbrir.getSelectedFile( );
			if (archivoDatos != null && archivoDatos.exists( ) && archivoDatos.isFile( ) ) {
				mg.setArchivoDatos( archivoDatos );
				/** Asignar el directorio de trabajo*/
				File dirT = archivoDatos.getParentFile( );
				if ( dirT != null && dirT.exists( ) && dirT.isDirectory( ) ) 
					mg.setDirectorioTrabajo( archivoDatos.getParentFile( ) );
				else
					mg.setDirectorioTrabajo( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getWorkspaceGprof( ) );
				/** Si hay un archivo de datos, el futuro nombre de la salida lo tomará de él.*/
				String nombre = archivoDatos.getName( ).substring( 0, archivoDatos.getName().lastIndexOf( '.' ) );
				mg.setNombreSalidaGprof( nombre );
				
				abrirDatosEjecucion( mg );
			}
			else {
				DialogoError.getInstance( ).showErrorDialog(  
						errores.getString("err_ArchivoDatos") );
			}
		}
	
	}

	public void gprof ( ) {
		JPanelGprof pg = getPanelActivo( );
		if ( pg != null ) {
			ModeloGprof mg = pg.getModel( );
			if ( mg != null ) {
				final String [] orden = mg.getComandoGprofAuto( );
				final File dirTrabajo = mg.getDirectorioTrabajo( );

				try {
					/** Ejecutar gprof */
					final Thread gprof = new EjecutorComandos( orden , dirTrabajo , pg );
					
					gprof.start( );
					
					/** hilo para actualizar botones cuando acabe la ejecución de gprof */
					new Thread() {
						public void run () {
							try {
								gprof.join();
								
								activarActions(visible);
								
							} catch ( InterruptedException e ) {
								DialogoError.getInstance( ).showErrorDialog(  
										errores.getString("err_errorGprof") );
								e.printStackTrace( );
							}
							
						}
					}.start( );
				} catch ( Exception e ) {

					DialogoError.getInstance( ).showErrorDialog(  
							errores.getString("err_errorGprof") );
				}
			}
		}
	}
	
	/**
	 * Método para cambiar el directorio de trabajo en la pestaña activa.
	 */
	public void cambiarDirectorioTrabajo ( ) {
		ModeloGprof mg = this.getModeloGprofActivo( );
		if ( mg != null ) {
			JDirectoryChooser dialogo = new JDirectoryChooser( new File( "/" ) );
			File directorio_inicial = mg.getDirectorioTrabajo( );
			if ( directorio_inicial != null ) {
				dialogo.setSelectedDirectory( directorio_inicial );
			}
			if ( dialogo.showDialog( gui ) == JDirectoryChooser.OK_OPTION ) {
				File directorio_final = dialogo.getSelectedDirectory( );
				if ( directorio_final != null && directorio_final.isDirectory( ) ) {
					mg.setDirectorioTrabajo( dialogo.getSelectedDirectory( ) );
				}
			}

		}
	}
	
	/**
	 * Método para cambiar el programa sobre el que se usará gprof en la pestaña activa.
	 * @param prog
	 */
	public void editarPrograma ( File prog ) {
		ModeloGprof mg = this.getModeloGprofActivo( );
		if ( mg != null ) {
				mg.setPrograma( prog );
		}
	}
	
	/**
	 * Método para cambiar el fichero de datos de la ejecución (gmon.out) sobre el que se usará gprof en la pestaña activa.
	 * @param datos
	 */
	public void editarDatosEjecucion ( File datos ) {
		ModeloGprof mg = this.getModeloGprofActivo( );
		if ( mg != null ) {
				mg.setArchivoDatos( datos );
				
				/** Ahora cambiamos el nombre. */
				String nombre = datos.getName( );
				nombre = nombre.substring( 0, 
						nombre.lastIndexOf( '.' ) );
				mg.setNombreSalidaGprof( nombre );
				
				pestañas.setTitleAt( pestañas.indexOfComponent( getPanelActivo() ) , mg.getNombreSalidaGprof( ) );
		}
	}

	public void editarDatosEjecucion ( ) {

		ModeloGprof mg = this.getModeloGprofActivo( );
		if ( mg != null ) {
			File dir = mg.getDirectorioTrabajo( );
			
			if ( dir != null) dialogoAbrir.setCurrentDirectory( dir );
				if( dialogoAbrir.showOpenDialogSalida( guigprof.getInstance( ).getGUI( ), false ) == JFileChooser.APPROVE_OPTION && dialogoAbrir.getSelectedFile( ) != null ) {
					File nuevoFichero = dialogoAbrir.getSelectedFile( );
					this.editarDatosEjecucion( nuevoFichero );
				}
		}
		
	}

	/**
	 * Método para editar el nombre del fichero de salida gprof 
	 */
	public void cambiarNombre ( ) {
		/** editarNombreGprof */
		JPanelGprof pg = getPanelActivo();
		if ( pg != null ) {
				ModeloGprof mg = pg.getModel( );

				DialogoCambiarNombre dialogo = new DialogoCambiarNombre( mg.getNombreSalidaGprof( ) );
				if( dialogo.showDialog( gui ) == DialogoCambiarNombre.OK_OPTION ) {
					String nombre = dialogo.getNombre();
					mg.setNombreSalidaGprof( nombre );
					
					int index = pestañas.indexOfComponent( pg );
					
					pestañas.setTitleAt( index , nombre );
					( (javax.swing.JLabel) pestañas.getTabComponentAt( index ) ).setText(nombre);
					pestañas.setToolTipText( nombre );
				}
		}
	}
	
	/**
	 * Método para editar el comando de gprof 
	 */
	public void editarComando ( ) {
		JPanelGprof pg = getPanelActivo();
		if ( pg != null ) {
				ModeloGprof mo = pg.getModel( );
				DialogoCambiarComando diaOrdenes = new DialogoCambiarComando( 
						guigprof.getInstance( ).getGUI( ) );
				diaOrdenes.setComando( mo.getComandoGprof( ) );
				diaOrdenes.setOnlyOptions( true );

				boolean ordenModificada = diaOrdenes.showDialog( );
				
				Vector <String> orden = diaOrdenes.getComando();
				
				if ( ordenModificada && orden != null && orden.size( ) > 0 ) {
					
					mo.setComandoGprof( orden );
					
				}

		}
	}
	
	public void cambiarFuente ( Font f ) {
		for (int i = 0; i < pestañas.getTabCount( ); i ++ ) {
			Component c = pestañas.getComponentAt( i );
			if( c instanceof JPanelGprof ) {
				( ( JPanelGprof ) c  ).cambiarFuente( f );
			}
		}
	}
	
	/******************* pestañas ***********************/
	
	public Vector < ModeloGprof > getModelos () {
		Vector < ModeloGprof > vModelos = new Vector < ModeloGprof >();
		
		for (int i = 0; i < pestañas.getTabCount( ); i ++ ) {
			Component c = pestañas.getComponentAt( i );
			if( c instanceof JPanelGprof ) {
				ModeloGprof moG = ( ( JPanelGprof ) c ).getModel( );
				if ( moG != null )
					vModelos.add( moG );
			}
		}
		
		return vModelos;
	}
	
	/** devuelve el modelo gprof del panel activo. Null si no hay ninguno; */
	public ModeloGprof getModeloGprofActivo() {
		ModeloGprof mo = null;
		JPanelGprof pc = getPanelActivo();
		if ( pc != null ) {
			mo = pc.getModel( );
		}
		return mo;
	}
	
	/** devuelve el panel activo. Null si no hay ninguno; */
	private JPanelGprof getPanelActivo () {
		JPanelGprof pc = null;
		if ( pestañas.getComponentCount() > 0 ) {
			Component c = pestañas.getSelectedComponent();
			if ( c instanceof JPanelGprof ) {
				pc = (JPanelGprof) c;
			}
		}
		return pc;
	}
	/****************Visibilidad********************/
	boolean visible = true;
	
	public void setActivo(boolean b){
		visible = b;
		setVisible(b);
		//también hay que anular las acciones que no correspondan.
		activarActions ( b );
		
		barraDeTareas.setEnabled(b);
		barraDeTareas.setVisible(b);
	}
	public boolean isActivo () {
		return visible;
	}
	public void activarActions ( boolean vistaActiva ) {
		boolean panelNoVacio = false;
		boolean siguientePaso = false;
		if ( vistaActiva && this.getPanelActivo( ) != null && !this.getPanelActivo( )
				.isVacio( ) ) {
			panelNoVacio = true;
		}
		if ( panelNoVacio == true && this.getPanelActivo( ).getModel( ).isGprofed( ) ) {
			siguientePaso = true;
		}
		
		CrearYGestionarAcciones a = CrearYGestionarAcciones.getInstance( );
		
		a.activarActionsGprof( vistaActiva, panelNoVacio , siguientePaso );
	}

}
