package modelo;


import java.util.ResourceBundle;
import java.util.Vector;

import modelo.vcompilacion.ModeloCompilacion;
import modelo.vedicion.ModeloEdicion;
import modelo.vejecucion.ModeloEjecucion;
import modelo.vestadisticas.ModeloEstadistica;
import modelo.vgprof.ModeloGprof;
import modelo.vtraduccion.ModeloTR;


public class Sesion {

	/** recursos para dar soporte de idiomas sobre errores */
	static ResourceBundle							errores				= ResourceBundle
																		.getBundle( "interfaz.errores.Errores" );

	/** vector con todos los modelos edición de la sesión */
	Vector < ModeloEdicion > 	 vMoEdicion = new Vector < ModeloEdicion > ( );
	/** vector con todos los modelos compilación de la sesión */
	Vector < ModeloCompilacion > vMoCompilacion = new Vector < ModeloCompilacion > ( );
	/** vector con todos los modelos ejecucion de la sesión */
	Vector < ModeloEjecucion > vMoEjecucion = new Vector < ModeloEjecucion > ( );
	/** vector con todos los modelos gprof de la sesión */
	Vector < ModeloGprof > vMoGprof = new Vector < ModeloGprof > ( );
	/** vector con todos los modelos traduccion de la sesión */
	Vector < ModeloTR > vMoTraduccion = new Vector < ModeloTR > ( );
	/** vector con todos los modelos estadísticas de la sesión */
	Vector < ModeloEstadistica > vMoEstadisticas = new Vector < ModeloEstadistica > ( );
	
	/** Document donde se guarda la info XML del fichero *//*
	Document docXML = null;*/

	/** Fichero donde se guardará o desde donde se recuperará la sesión *//*
	File sesionFile = null;*/

	
	/*public Sesion ( File fichero ) {
	
		sesionFile = fichero;	 
	}*/

	public Sesion ( ) {

	}
	

	
	public void vaciarSesion () {
		vMoEdicion.clear( );
		vMoCompilacion.clear( );
		vMoEjecucion.clear( );
		vMoGprof.clear( );
		vMoTraduccion.clear( );
		vMoEstadisticas.clear( );
	}



	

	public boolean isVacia() {
		return false;
	}

	public Vector < ModeloEdicion > getModelosEdicion ( ) {
		return vMoEdicion;
	}

	public Vector < ModeloCompilacion > getModelosCompilacion ( ) {
		return vMoCompilacion;
	}

	public Vector < ModeloEjecucion > getModelosEjecucion ( ) {
		return vMoEjecucion;
	}

	public Vector < ModeloGprof > getModelosGprof ( ) {
		return vMoGprof;
	}

	public Vector < ModeloTR > getModelosTraduccion ( ) {
		return vMoTraduccion;
	}

	public Vector < ModeloEstadistica > getModelosEstadisticas ( ) {
		return vMoEstadisticas;
	}

	public void addVMEdicion ( Vector < ModeloEdicion > vme ) {
		vMoEdicion.addAll( vme );
		
	}

	public void addVMCompilacion ( Vector < ModeloCompilacion > vmc ) {
		vMoCompilacion.addAll( vmc );
		
	}

	public void addVMEjecucion ( Vector < ModeloEjecucion > vmj ) {
		vMoEjecucion.addAll( vmj );
		
	}

	public void addVMGprof ( Vector < ModeloGprof > vmg ) {
		vMoGprof.addAll( vmg );
		
	}

	public void addVMTR ( Vector < ModeloTR > vmt ) {
		vMoTraduccion.addAll( vmt );
		
	}

	public void addVMEstadistica ( Vector < ModeloEstadistica > vms ) {
		vMoEstadisticas.addAll( vms );
		
	}
	
	public void setVMEdicion ( Vector < ModeloEdicion > vme ) {
		vMoEdicion = vme;
		
	}

	public void setVMCompilacion ( Vector < ModeloCompilacion > vmc ) {
		vMoCompilacion = vmc;
		
	}

	public void setVMEjecucion ( Vector < ModeloEjecucion > vmj ) {
		vMoEjecucion = vmj;
		
	}

	public void setVMGprof ( Vector < ModeloGprof > vmg ) {
		vMoGprof = vmg;
		
	}

	public void setVMTR ( Vector < ModeloTR > vmt ) {
		vMoTraduccion = vmt;
		
	}

	public void setVMEstadistica ( Vector < ModeloEstadistica > vms ) {
		vMoEstadisticas = vms;
		
	}
}
