/**
 * 
 */
package modelo.vedicion;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.ficheros.UtilidadesFichero;


/**
 * @author angel2
 *
 */
public class ModeloEdicion {

	File fichero = null;
		
	ArrayList < ChangeListener >	listeners			= new ArrayList < ChangeListener >( 0 ); // listeners
		
	public void addChangeListener ( ChangeListener listener ) {
		listeners.add( listener );
	}

	public void removeChangeListener ( ChangeListener listener ) {
		listeners.remove( listener );
	}
	
	private void OnChange ( ) {
		ChangeEvent e = new ChangeEvent( this );
		Iterator < ChangeListener > it = listeners.iterator( );
		while ( it.hasNext( ) ) {
			it.next( ).stateChanged( e );
		}
	}

	
	/**
	 * @param f
	 * @param pestañaNueva
	 */
	public void setFichero( File f) {
		fichero = f;
		OnChange();
	}

	public File getFichero() {
		return fichero;
	}
	
	/** Devuelve el contenido del fichero mostrado como un <code>String</code>. */
	public String getTexto () {
		return fichero != null? new UtilidadesFichero().leerFichero(fichero) : new String ("");
	}
	
	public void actualizar ( ) {
		OnChange();
	}

	public boolean isCompilable ( ) {
		return this.getFichero( ) != null && this.getFichero( ).exists( );
	}
}

