/**
 * 
 */
package modelo.vestadisticas.perfilplano;



import java.util.ArrayList;
import java.util.Iterator;

import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

import negocio.PreferenciasSingleton;

import modelo.modeloXML.InterfazModeloXML;
import modelo.modeloXML.LineaPerfilPlano;
import modelo.modeloXML.ModeloXML;
import modelo.vestadisticas.ModeloEstadistica;



/**
 * @author angel
 *
 */
public class ModeloTablaPerfilPlano extends AbstractTableModel implements InterfazModeloXML {
	private final static long serialVersionUID = 1;
	
	private ModeloXML moXML;
	
	private ArrayList<TableModelListener> arrayListeners = new ArrayList<TableModelListener>();
	
	private ResourceBundle propiedades = ResourceBundle.getBundle("interfaz.idiomas.Recursos", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	private double totalSegundos = 0;
	
	private Vector < Double > tiempoAcumulado = new Vector <Double>(); 

	final String[] nombreDeColumnas = { 
			propiedades.getString("eti_MoGL_nombre"),
			propiedades.getString("eti_MoGL_porcentaje"),
			propiedades.getString("eti_MoGL_tpropio"),
			propiedades.getString("eti_MoPP_acumulado"),
			propiedades.getString("eti_MoGL_llamadas"),
			propiedades.getString("eti_MoPP_etiempoXllamada"),
			propiedades.getString("eti_MoPP_etiempoTotalXllamada")};
	
	public final static int NOMBRE = 0;
	public final static int PORCENTAJE = 1;
	public final static int TPROPIO = 2;
	public final static int TACUMULADO = 3;
	public final static int LLAMADAS = 4;
	public final static int TXLLAMADA = 5;
	public final static int TTXLLAMADA = 6;

	private Vector < LineaPerfilPlano > perfilplano = new Vector < LineaPerfilPlano > (0);

	public ModeloTablaPerfilPlano() {
	}

	/**
	 * Usa un árbol DOM XML ya existente.
	 * 
	 * @param d
	 *            Árbol DOM de un documento XML ya analizado.
	 */
	public ModeloTablaPerfilPlano (ModeloEstadistica x) {
		setDatosXML( x );
	}
	
	/**************METODOS**************/
	public void addTreeModelListener(TableModelListener l) {
		arrayListeners.add(l);
	}

	public void removeTreeModelListener(TableModelListener l) {
		arrayListeners.remove(l);
	}

	
	public int getColumnCount() {
		return nombreDeColumnas.length;
	}

	public Class <?> getColumnClass( int columnIndex ) {
		Class <?> result = String.class;
		switch (columnIndex) {
		case NOMBRE: result = String.class; break;
		case PORCENTAJE: result = Double.class; break;
		case TPROPIO: result = Double.class; break;
		case TACUMULADO: result = Double.class; break;
		case LLAMADAS: result = Integer.class; break;
		case TXLLAMADA: result = Double.class; break;
		case TTXLLAMADA: result = Double.class; break;
		}

		return result;
	}
	
	public int getRowCount() {
		return perfilplano.size();
	}

	public String getColumnName(int col) {
		return nombreDeColumnas[col];
	}

	public Object getValueAt(int row, int col) {
		Object result = null;
		if ( moXML != null && row >= 0 && row < getRowCount() && col >= 0 && col < getColumnCount() ) {
			switch (col) {
			case NOMBRE: result = perfilplano.get(row).getNombreFuncion(); break;
			case PORCENTAJE: result = totalSegundos != 0? perfilplano.get( row ).getTiempoPropio( ).doubleValue( ) / totalSegundos : 0; break;
			case TPROPIO: result = perfilplano.get(row).getTiempoPropio(); break;
			case TACUMULADO: result = tiempoAcumulado.get( row ); break;
			case LLAMADAS: result = ( perfilplano.get(row).isEspontanea() ) ? null : perfilplano.get(row).getNumeroLlamadas(); break;
			case TXLLAMADA: result = ( perfilplano.get(row).isEspontanea() ) ? null : perfilplano.get(row).getEstimacionTiempoPropioPorLlamada(); break;
			case TTXLLAMADA: result = ( perfilplano.get(row).isEspontanea() ) ? null : perfilplano.get(row).getEstimacionTiempoTotalPorLlamada(); break;
			}
		}
		return result;
	}

	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public void setValueAt (Object value, int row, int col) {
		//Insertar. Esta tabla es de solo lectura. No necesita hacer nada.
	}


	public void setDatosXML(ModeloEstadistica me ) {
		ModeloXML x = me.getModeloXML( );
		if ( x != null && x.hasPerfilPlano() ) {
			moXML = x;
			perfilplano = moXML.getPerfilPlano();
			inicializar();
			fireTableDataChanged();
		}		
	}
	
	/**
	 * Esta función genera la información derivada del modelo de datos,
	 * como el tiempo acumulado y el tiempo total.
	 */
	private void inicializar () {
		double tiempoAcumulado_d = 0; 
		
		this.tiempoAcumulado = new Vector <Double> (perfilplano.size( ) );
		
		Iterator <LineaPerfilPlano> itpp = perfilplano.iterator( );
		while ( itpp.hasNext( ) ) {
			tiempoAcumulado_d += itpp.next( ).getTiempoPropio( ).doubleValue( );
			this.tiempoAcumulado.add( new Double( tiempoAcumulado_d ) );
		}
		
		this.totalSegundos = tiempoAcumulado_d;
	}
}

