package modelo.vtraduccion;

import interfaz.dialogos.error.DialogoError;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import modelo.ficheros.UtilidadesFichero;
import negocio.PreferenciasSingleton;

public class ModeloTR {

	/** recursos de idiomas para errores */
	static ResourceBundle errores = ResourceBundle.getBundle("interfaz.errores.Errores", 
			PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getLocale( ) );
	
	private File					ficheroSalida = null;
	
	private File					XML	= null;
	
	private String					nombreXML = null;
	
	private File					directorioTrabajo	= PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getWorkspaceTR( );

	private String	salida_s;
	
	private Vector <String> traductor = PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getComandoTraductor(  );

	public static String extension1 = ".gprof";
	public static String extension2 = ".xml";
	public static String extension = ".gprof.xml";


	public ModeloTR ( File ficheroSalida ) {
		this.setFicheroSalida( ficheroSalida );
		this.setNombreXML( ficheroSalida.getName( ) );
	}

	public ModeloTR ( ) {
		
	}

	/********* listeners **************/
	ArrayList < ChangeListener >	listeners			= new ArrayList < ChangeListener >( 0 ); // listeners

	
	public void addChangeListener ( ChangeListener listener ) {
		listeners.add( listener );
	}

	public void removeChangeListener ( ChangeListener listener ) {
		listeners.remove( listener );
	}

	/********** on change ***********/
	private void OnChange ( ) {
		ChangeEvent e = new ChangeEvent( this );
		Iterator < ChangeListener > it = listeners.iterator( );
		while ( it.hasNext( ) ) {
			it.next( ).stateChanged( e );
		}
	}

	/******** métodos ******************/

	public File getDirectorioTrabajo ( ) {
		return directorioTrabajo;
	}

	public String getNombreXML ( ) {		
		return nombreXML;
	}

	public File getFicheroSalida ( ) {
		return ficheroSalida;
	}

	
	public File getFicheroXML (){
		if ( this.XML == null && this.getNombreXML( ) != null ) {
			this.XML = new File( this
					.getDirectorioTrabajo( ) , this.getNombreXML( ) ); 
		}
		return this.XML;
	}

	public String getSalidaXML() {
		return salida_s;
	}

	public boolean istraducedToXML ( ) {
		File xml = this.getFicheroXML( );
		return ( xml != null && xml.exists( ) );
	}

	public void setSalidaXML ( String salida ) {
		this.salida_s = salida;	
		OnChange();
	}

	public void setFicheroXML ( File file ) {
		this.XML = file;
		OnChange();		
	}
	

	public void setDirectorioTrabajo ( File dir ) {
		this.directorioTrabajo = dir;
		OnChange( );
	}

	
	public void setNombreXML ( String nombre ) {
		if ( nombre != null && nombre.compareTo( "" ) != 0 ) {
			if ( nombre.endsWith( extension1 ) ) {
				nombre += extension2;
			}
		
			if ( !nombre.endsWith( extension ) ) {
				nombre += extension;
			}
		}
		else 
			nombre = null;
		
		this.nombreXML = nombre;
		OnChange( );
	}

	public void setFicheroSalida ( File s ) {
		this.ficheroSalida = s;
		this.setNombreXML( this.ficheroSalida.getName( ) );
		OnChange();
	}

	/********* generar Comando/Orden *****/
	public String [] getComandoTRAuto ( ) {

		LinkedList  < String > resultado = new LinkedList < String >( );
		// 1º) Preparar orden Gprof ****************

		// 1.a) orden tr 
		resultado.addAll( this.getComandoTR( ) );
		
		// 1.b) añadir ficheroSalida
		File normal = getFicheroSalida();
		if ( normal != null && normal.exists( ) ) {
			if ( PreferenciasSingleton.getPreferenciasSingleton( ).getPreferencias( ).getUseCanonicalFileName( ) ) {
				try {
					resultado.add( normal.getCanonicalPath( ) );
				} catch ( IOException e ) {
					resultado.add( normal.getName( ) );
				}
			} else { // cortos
				try {
					resultado.add( new UtilidadesFichero( ).getRelativePath(
							getDirectorioTrabajo( ) , normal ) );
				} catch ( IOException e ) {
					DialogoError.getInstance( ).showErrorDialog(
							errores.getString( "err_relativepath" ) );
				}
			}
		}
		
		
/*		// 1.c) añadir nombreXML
		String salida = this.getNombreSalidaTR( );
		resultado.add( "-o" );
		resultado.add( salida );*/
		
		String [] t = new String [resultado.size( )];
		return resultado.toArray( t );
	}

	public Vector <String> getComandoTR ( ) {
		return traductor;
	}
	
	public void setComandoTR ( Vector <String> vs ) {
		if ( vs != null && vs.size( ) > 0 ) {
			traductor = vs;
		
			OnChange();
		}
	}


}
